<template>
  <div>
    <gz-data-table
      ref="gzdatatable"
      form-key="integration-list"
      data-list-key="IntegrationDataList"
      :show-select="rights.read"
      :reload="reload"
      data-cy="integrationsTable"
      @selection-change="handleSelected"
    >
    </gz-data-table>
  </div>
</template>
<script>
const FORM_KEY = "integration-list";
export default {
  data() {
    return {
      rights: window.$gz.role.defaultRightsObject(),
      aType: window.$gz.type.Integration,
      selectedItems: [],
      reload: false
    };
  },
  created() {
    this.rights = window.$gz.role.getRights(window.$gz.type.Integration);
    window.$gz.eventBus.$on("menu-click", clickHandler);
    generateMenu(this);
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    handleSelected(selected) {
      this.selectedItems = selected;
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "new":
        m.vm.$router.push({
          name: "integration-edit",
          params: { recordid: 0 }
        });
        break;

      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu() {
  const menuOptions = {
    isMain: true,
    icon: "$ayiCampground",
    title: "IntegrationList",
    helpUrl: "adm-integrations",
    menuItems: [],
    formData: {
      ayaType: window.$gz.type.Integration
    }
  };

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}
</script>
